function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { isDarkMode } from '@cloudflare/style-const';
import { ariaAttributes, createStyledComponent } from '@cloudflare/style-container';
import { Icon } from '@cloudflare/component-icon';
var borderRadius = '4px';

var standardColors = (theme, state) => {
  var _theme$colors$button$, _theme$colors$button$2, _theme$colors$button$3, _theme$colors$button$4, _theme$colors$button$5, _theme$colors$button$6, _theme$colors$button$7;

  var color = theme.colors.gray[9];
  return {
    default: isDarkMode() ? color : theme.colors.gray[1],
    success: color,
    warning: color,
    inverted: {
      danger: (_theme$colors$button$ = theme.colors.button.plainDestructive[state]) === null || _theme$colors$button$ === void 0 ? void 0 : _theme$colors$button$.text,
      primary: (_theme$colors$button$2 = theme.colors.button.plain[state]) === null || _theme$colors$button$2 === void 0 ? void 0 : _theme$colors$button$2.text
    },
    primary: ((_theme$colors$button$3 = theme.colors.button.primary[state]) === null || _theme$colors$button$3 === void 0 ? void 0 : _theme$colors$button$3.text) || color,
    danger: ((_theme$colors$button$4 = theme.colors.button.danger[state]) === null || _theme$colors$button$4 === void 0 ? void 0 : _theme$colors$button$4.text) || color,
    plain: ((_theme$colors$button$5 = theme.colors.button.plain[state]) === null || _theme$colors$button$5 === void 0 ? void 0 : _theme$colors$button$5.text) || color,
    plainMono: ((_theme$colors$button$6 = theme.colors.button.plainMono[state]) === null || _theme$colors$button$6 === void 0 ? void 0 : _theme$colors$button$6.text) || color,
    plainDestructive: ((_theme$colors$button$7 = theme.colors.button.plainDestructive[state]) === null || _theme$colors$button$7 === void 0 ? void 0 : _theme$colors$button$7.text) || color
  };
};

var buttonColors = theme => {
  var standardIndex = isDarkMode() ? 3 : 4;
  var hoverIndex = isDarkMode() ? 1 : 2;
  return {
    // Normal default state colors
    normal: {
      backgroundColor: {
        default: isDarkMode() ? theme.colors.gray[standardIndex] : theme.colors.gray[8],
        primary: theme.colors.button.primary.normal.background,
        success: theme.colors.green[standardIndex],
        warning: theme.colors.orange[standardIndex],
        danger: theme.colors.button.danger.normal.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.normal.background,
          primary: theme.colors.button.plain.normal.background
        },
        plain: 'transparent',
        plainMono: 'transparent',
        plainDestructive: 'transparent'
      },
      color: standardColors(theme, 'normal')
    },
    // Hover
    hover: {
      backgroundColor: {
        default: theme.colors.gray[isDarkMode() ? 2 : 7],
        primary: theme.colors.button.primary.hover.background,
        success: theme.colors.green[hoverIndex],
        warning: theme.colors.orange[hoverIndex],
        danger: theme.colors.button.danger.hover.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.hover.background,
          primary: theme.colors.button.plain.hover.background
        },
        plain: theme.colors.button.plain.hover.background,
        plainMono: theme.colors.button.plainMono.hover.background,
        plainDestructive: theme.colors.button.plainDestructive.hover.background
      },
      color: standardColors(theme, 'hover')
    },
    // Active
    active: {
      backgroundColor: {
        default: theme.colors.gray[isDarkMode() ? 3 : 6],
        primary: theme.colors.button.primary.active.background,
        success: theme.colors.green[standardIndex],
        warning: theme.colors.orange[standardIndex],
        danger: theme.colors.button.danger.active.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.active.background,
          primary: theme.colors.button.plain.active.background
        },
        plain: theme.colors.button.plain.active.background,
        plainMono: theme.colors.button.plainMono.active.background,
        plainDestructive: theme.colors.button.plainDestructive.active.background
      },
      color: standardColors(theme, 'active')
    },
    // Focus
    focus: {
      backgroundColor: {
        default: theme.colors.gray[isDarkMode() ? 2 : 7],
        primary: theme.colors.button.primary.focus.background,
        success: theme.colors.green[standardIndex],
        warning: theme.colors.orange[standardIndex],
        danger: theme.colors.button.danger.focus.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.focus.background,
          primary: theme.colors.button.plain.focus.background
        },
        plain: theme.colors.button.plain.focus.background,
        plainMono: theme.colors.button.plainMono.focus.background,
        plainDestructive: theme.colors.button.plainDestructive.focus.background
      },
      color: standardColors(theme, 'focus')
    }
  };
};

var colorAccessor = (property, _ref) => {
  var {
    inverted = false,
    type = 'default'
  } = _ref;
  return !property ? undefined : inverted && (type === 'danger' || type === 'primary') ? property.inverted[type] : property[type];
};

var interactionStyleAccessor = (interactionState, props) => {
  var {
    theme,
    loading,
    disabled
  } = props;
  var isInteractive = !(loading || disabled);
  var stateStyles = buttonColors(theme)[interactionState];
  var color = colorAccessor(stateStyles.color, props);
  var backgroundColor = colorAccessor(stateStyles.backgroundColor, props);
  return isInteractive ? {
    backgroundColor,
    color,
    boxShadow: props.inverted ? "inset 0px 0px 0px 1px ".concat(color) : undefined
  } : undefined;
};

export var buttonStyles = props => {
  var _styles$buttonState, _styles$buttonState2;

  var {
    theme,
    loading = false,
    disabled,
    direction,
    group,
    spaced,
    space = 2,
    type = 'default',
    stretch,
    noWrapText,
    buttonState,
    compact
  } = props;
  var styles = {
    normal: buttonColors(theme).normal,
    hover: interactionStyleAccessor('hover', props),
    active: interactionStyleAccessor('active', props),
    focus: interactionStyleAccessor('focus', props)
  };
  var color = buttonState && styles[buttonState] ? (_styles$buttonState = styles[buttonState]) === null || _styles$buttonState === void 0 ? void 0 : _styles$buttonState.color : colorAccessor(styles.normal.color, props);
  var backgroundColor = buttonState && styles[buttonState] ? (_styles$buttonState2 = styles[buttonState]) === null || _styles$buttonState2 === void 0 ? void 0 : _styles$buttonState2.backgroundColor : colorAccessor(styles.normal.backgroundColor, props);
  return _objectSpread(_objectSpread(_objectSpread({}, buttonState ? {} : {
    '&:focus': styles.focus,
    '&:hover': styles.hover,
    '&:active': styles.active,
    '&:focus:active': styles.active
  }), {}, {
    '&:focus-visible': {
      outlineOffset: 2,
      outlineWidth: 2,
      outlineStyle: 'solid',
      outlineColor: type === 'danger' || type === 'plainDestructive' ? theme.colors.red[isDarkMode() ? 3 : 4] : theme.colors.focus
    },
    '&[title]': {
      pointerEvents: disabled ? 'auto' : 'none'
    },
    backgroundColor,
    color: loading ? 'transparent' : color,
    cursor: disabled || loading ? 'default' : 'pointer',
    display: 'inline-flex',
    gap: 1,
    flexGrow: stretch ? 1 : undefined,
    alignItems: 'center',
    justifyContent: 'center',
    fontFamily: theme.fontFamily,
    fontSize: compact ? 1 : 2,
    fontWeight: 500,
    lineHeight: 1.2,
    border: 'none'
  }, props.inverted ? {
    boxShadow: "inset 0px 0px 0px 1px ".concat(color)
  } : {}), {}, {
    borderTopRightRadius: (group === 'first' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    borderTopLeftRadius: (group === 'last' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    borderBottomLeftRadius: (group === 'last' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    borderBottomRightRadius: (group === 'first' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    '&::before': loading ? {
      content: '"•••"',
      color,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      position: 'absolute',
      left: 0,
      height: '100%',
      width: '100%',
      opacity: 1,
      animationName: {
        '50%': {
          opacity: 0
        }
      },
      animationDuration: '1s',
      animationIterationCount: 'infinite',
      animationTimingFunction: 'linear'
    } : {
      display: 'none'
    },
    opacity: disabled ? 0.5 : 'inherit',
    mt: spaced && direction === 'column' && group !== 'first' ? space : 0,
    mr: 0,
    mb: 0,
    ml: spaced && direction === 'row' && group !== 'first' ? space : 0,
    px: compact ? '11px' : 3,
    py: compact ? 1 : 2,
    pointerEvents: disabled ? 'none' : 'auto',
    position: 'relative',
    textAlign: 'center',
    transitionProperty: 'all',
    transitionDuration: '300ms',
    transitionTimingFunction: 'ease',
    userSelect: 'none',
    maxWidth: 'initial',
    float: 'none',
    whiteSpace: noWrapText ? 'nowrap' : 'normal',
    width: direction === 'column' ? '100%' : 'auto'
  });
};
var Button = /*#__PURE__*/React.forwardRef((props, ref) => {
  var {
    id,
    name,
    submit = false,
    className,
    disabled,
    loading = false,
    testId,
    children,
    onClick,
    iconType,
    iconLabel,
    iconProps,
    iconSize,
    iconPosition = 'left',
    form,
    tabIndex,
    ariaLabel
  } = props;
  var ariaAndDataProps = Object.keys(props).filter(propName => propName.startsWith('data-') || ariaAttributes.includes(propName)).reduce((memo, propName) => _objectSpread(_objectSpread({}, memo), {}, {
    [propName]: props[propName]
  }), {});
  return /*#__PURE__*/React.createElement("button", _extends({}, ariaAndDataProps, {
    id: id,
    name: name,
    type: submit ? 'submit' : 'button',
    "data-testid": testId,
    disabled: disabled || loading,
    className: className,
    onClick: onClick,
    form: form,
    tabIndex: tabIndex,
    ref: ref,
    "aria-label": ariaLabel
  }), iconType && iconPosition === 'left' && /*#__PURE__*/React.createElement(Icon, _extends({
    size: iconSize,
    type: iconType,
    ariaLabel: iconLabel
  }, iconProps)), children, iconType && iconPosition === 'right' && /*#__PURE__*/React.createElement(Icon, _extends({
    size: iconSize,
    type: iconType,
    ariaLabel: iconLabel
  }, iconProps)));
});
Button.propTypes = {
  id: PropTypes.string,
  name: PropTypes.string,
  onClick: PropTypes.func,
  submit: PropTypes.bool,
  spaced: PropTypes.bool,
  space: PropTypes.number,
  direction: PropTypes.oneOf(['column', 'row']),
  className: PropTypes.string,
  group: PropTypes.oneOf(['first', 'inbetween', 'last']),
  type: PropTypes.oneOf(['default', 'primary', 'success', 'warning', 'danger', 'plain', 'plainMono', 'plainDestructive']),
  testId: PropTypes.string,
  disabled: PropTypes.bool,
  loading: PropTypes.bool,
  inverted: PropTypes.bool,
  iconType: PropTypes.string,
  iconLabel: PropTypes.string,
  iconSize: PropTypes.number,
  form: PropTypes.string,
  tabIndex: PropTypes.number,
  ariaLabel: PropTypes.string,
  stretch: PropTypes.bool,
  noWrapText: PropTypes.bool,
  buttonState: PropTypes.oneOf(['hover', 'active', 'focus']),
  compact: PropTypes.bool
};
Button.displayName = 'Button';
export default createStyledComponent(buttonStyles, Button);