import { createStyledComponent } from '@cloudflare/style-container';
import { isDarkMode } from '@cloudflare/style-const';
var TextButton = createStyledComponent(_ref => {
  var {
    theme
  } = _ref;
  return {
    background: 'transparent',
    borderRadius: 'none',
    color: theme.colors.blue[4],
    cursor: 'pointer',
    transitionProperty: 'color',
    transitionDuration: '150ms',
    transitionTimingFunction: 'ease',
    padding: '0px',
    display: 'inline-block',
    alignItems: 'center',
    lineHeight: '1.5',
    height: 'fit-content',
    fontSize: 2,
    fontWeight: 400,
    outline: 'none',
    overflow: 'hidden',
    textUnderlineOffset: 4,
    ':hover': {
      color: isDarkMode() ? theme.colors.orange[6] : theme.colors.blue[2],
      textDecoration: 'underline'
    },
    ':focus-visible': {
      outline: '-webkit-focus-ring-color auto 1px',
      outlineOffset: '1px'
    }
  };
}, 'button');
TextButton.displayName = 'TextButton';
export default TextButton;