"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getGroupByIndex = function getGroupByIndex(index, length) {
  if (index === length - 1) {
    return 'last';
  }

  if (index === 0) {
    return 'first';
  }

  return 'inbetween';
};

var addGroupProps = function addGroupProps(children, spaced, space, direction, stretch) {
  return _react.default.Children.map(children, function (child, index) {
    if ( /*#__PURE__*/_react.default.isValidElement(child)) {
      return /*#__PURE__*/_react.default.cloneElement(child, {
        group: getGroupByIndex(index, _react.default.Children.count(children)),
        spaced: spaced,
        space: space,
        direction: direction,
        stretch: stretch
      });
    }

    return child;
  });
};

var ButtonGroup = function ButtonGroup(_ref) {
  var className = _ref.className,
      children = _ref.children,
      spaced = _ref.spaced,
      space = _ref.space,
      _ref$direction = _ref.direction,
      direction = _ref$direction === void 0 ? 'row' : _ref$direction,
      stretch = _ref.stretch;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: className
  }, addGroupProps(children, spaced, space, direction, stretch));
};

ButtonGroup.propTypes = {
  spaced: _propTypes.default.bool,
  space: _propTypes.default.number,
  stretch: _propTypes.default.bool,
  className: _propTypes.default.string.isRequired,
  direction: _propTypes.default.oneOf(['column', 'row'])
};
ButtonGroup.displayName = 'ButtonGroup';

var _default = (0, _styleContainer.createStyledComponent)(function (_ref2) {
  var _ref2$direction = _ref2.direction,
      direction = _ref2$direction === void 0 ? 'row' : _ref2$direction;
  return {
    position: 'relative',
    display: 'inline-flex',
    width: direction === 'column' ? '100%' : 'initial',
    flexDirection: direction === 'column' ? 'column' : 'row',
    flexWrap: 'nowrap'
  };
}, ButtonGroup);

exports.default = _default;